require "her_palindrome/version"

module HerPalindrome

  # Returns true for a palindrome, false otherwise.
  def palindrome?
    if processed_content.empty?
      false
    else
      processed_content == processed_content.reverse
    end
  end

  # Returns the letters in the string.
  # def letters
  #   the_letters = []
  #   for i in 0..self.length - 1 do
  #     if self[i].match(/[a-zA-Z]/)
  #       the_letters << self[i]
  #     end
  #   end
  #   the_letters.join
  # end

  # def letters
  #   the_letters = []
  #   letter_regex = /[a-z]/i
  #   self.chars.each do |character|
  #     if character.match(letter_regex)
  #       the_letters << character
  #     end
  #   end
  #   the_letters.join
  # end

  # def letters
  #   chars.select { |c| c.match(/[a-z]/i) }.join
  # end

  private

    # Returns content for palindrome testing.
    def processed_content
      self.to_s.scan(/[a-z\d]/i).join.downcase
    end
end

class String
  include HerPalindrome
end

class Integer
  include HerPalindrome
end
